
#include <Arduino_AdvancedAnalog.h>
#define BUFSIZE 8
#define NBUF 4
uint32_t sample_rate = 50000;
double sample_period;
AdvancedDAC dac0(A12);
AdvancedDAC dac1(A13);
uint32_t count;
double phi0,phi1;
double deuxpi = 2*PI;

// transformation nombre -> tension
float offset = 2048;
float num2volt = 3.217/4096;
float volt2num = 4096/3.217;

// définition des signaux
float f0 = 1000.0;
float f1 = 1000.0;

float signal0(float phi) {
  return 0.5*sin(deuxpi*phi);
}

float signal1(float phi) {
  return 0.5*sin(deuxpi*phi);
}

void setup() {
  pinMode(13,OUTPUT);
  count = 0;
  sample_period = 1.0/sample_rate; 
  Serial.begin(115200);
  while(!Serial);
  if (!dac0.begin(AN_RESOLUTION_12, sample_rate,BUFSIZE, NBUF)) {
    Serial.println("Echec de démarrage de DAC0");
      while (1);
  }
  if (!dac1.begin(AN_RESOLUTION_12, sample_rate,BUFSIZE, NBUF)) {
    Serial.println("Echec de démarrage de DAC1");
      while (1);
  }
}

void loop() {
  if (dac0.available()&&dac1.available()) {
      GPIOH->BSRR |= GPIO_BSRR_BS6; //digitalWrite(13,HIGH);
      SampleBuffer buf_dac0 = dac0.dequeue();
      uint16_t *buf_dac0_data = buf_dac0.data();
      SampleBuffer buf_dac1 = dac1.dequeue();
      uint16_t *buf_dac1_data = buf_dac1.data();
      
      for (uint16_t i=0; i<BUFSIZE; i++) {
          phi0 += f0*sample_period;
          phi1 += f1*sample_period;
          if (phi0 > 1) phi0 -= 1.0;
          if (phi1 > 1) phi1 -= 1.0;
          buf_dac0_data[i] = signal0(phi0)*volt2num + offset;
          buf_dac1_data[i] = signal1(phi1)*volt2num + offset;
      }
      dac0.write(buf_dac0);
      dac1.write(buf_dac1);
      GPIOH->BSRR |= GPIO_BSRR_BR6; //digitalWrite(13,LOW);
  }
  
}



                   